(* AUTEURS / AUTHORS :                          *)
(* Judicaël Courant,   Jean-François Monin      *)
(* VERIMAG, Université Joseph Fourier, Grenoble *)
(*                                         2006 *)

(* $Id: RelProps.v,v 1.2 2006/03/08 13:35:24 monin Exp $ *)

Definition is_equal A (R: A->A->Prop) := forall x y, R x y -> x=y.
Implicit Arguments is_equal [A].

Definition reflexive A (R: A->A->Prop) := forall x, R x x.
Implicit Arguments reflexive [A].

Definition irreflexive A (R: A->A->Prop) := forall x, ~R x x.
Implicit Arguments irreflexive [A].

Definition transitive A (R: A->A->Prop) :=
  forall x y z, R x y -> R y z -> R x z.
Implicit Arguments transitive [A].

Definition incompatibles A (Q R: A->A->Prop) :=
  forall x y, Q x y -> R x y -> False.
Implicit Arguments incompatibles [A].

Definition rel_unique A (R: A->A->Prop) := forall (x y: A) (r1 r2: R x y), r1 = r2.
Implicit Arguments rel_unique [A].

Definition prop_unique A (P: A->Prop) := forall (x: A) (p1 p2: P x), p1 = p2.
Implicit Arguments prop_unique [A].
