(* AUTEURS / AUTHORS :                          *)
(* Judicaël Courant,   Jean-François Monin      *)
(* VERIMAG, Université Joseph Fourier, Grenoble *)
(*                                         2006 *)

(* $Id: SortEmpty.v,v 1.2 2006/03/08 13:35:24 monin Exp $ *)

Require Import RelProps.
Require Import Separable.
Require Import Empty.

Definition ueq_empty (e1 e2: empty) : Prop := match e1 with end.

Theorem ueq_empty_True_False : rel_True_False ueq_empty.
intro x; case x.
Qed.

Theorem ueq_empty_equal : is_equal ueq_empty.
intro x; case x.
Qed.

Theorem ueq_empty_refl : reflexive ueq_empty.
intro x; case x.
Qed.

Definition ult_empty (e1 e2: empty) : Prop := match e1 with end.

Theorem ult_empty_True_False : rel_True_False ult_empty.
intro x; case x.
Qed.

Theorem ult_ueq_empty_False : incompatibles ult_empty ueq_empty.
intro x; case x.
Qed.

Theorem ult_empty_trans : transitive ult_empty.
intro x; case x.
Qed.

Theorem ult_empty_total : total ult_empty. 
intro x; case x.
Qed.

(* *)

Definition Sempty :=
   mksrt ueq_empty_True_False ueq_empty_equal ueq_empty_refl 
         ult_empty_True_False ult_ueq_empty_False ult_empty_trans ult_empty_total.
