(* AUTEURS / AUTHORS :                          *)
(* Judicaël Courant,   Jean-François Monin      *)
(* VERIMAG, Université Joseph Fourier, Grenoble *)
(*                                         2006 *)

(* $Id: Terms.v,v 1.3 2006/03/08 13:35:24 monin Exp $ *)

Inductive secret_const : Set :=
  | KM : secret_const
  | KEK : secret_const
  | P : secret_const
  | KEK2 : secret_const
  | EXP1 : secret_const
.

Inductive public_const : Set :=
  | DATA : public_const
  | PIN : public_const
  | ID : public_const
  | IMP : public_const
  | K3 : public_const
  | ACC : public_const
  | KP : public_const
  | EXP : public_const
.

Inductive term : Set :=
  | Zero : term
  | PC :> public_const -> term (* public constants *)
  | SC :> secret_const -> term (* secret constants *)
  | E : term -> term -> term
  | Xor : term -> term -> term
  | Hash : term -> term -> term
.
